import { Network } from "@wormhole-foundation/sdk-base";
import { CircleAttestation, CircleMessageId, ProtocolVAA, Signer, TransactionId, TxHash, WormholeMessageId } from "@wormhole-foundation/sdk-definitions";
import { CircleTransferDetails } from "../types";
import { Wormhole } from "../wormhole";
import { AttestationId, TransferState, WormholeTransfer } from "../wormholeTransfer";
export type AutomaticCircleBridgeVAA<PayloadName extends string> = ProtocolVAA<"AutomaticCircleBridge", PayloadName>;
export declare class CircleTransfer<N extends Network> implements WormholeTransfer {
    private readonly wh;
    private state;
    transfer: CircleTransferDetails;
    txids: TransactionId[];
    circleAttestations?: {
        id: CircleMessageId;
        attestation?: CircleAttestation;
    }[];
    vaas?: {
        id: WormholeMessageId;
        vaa?: AutomaticCircleBridgeVAA<"TransferRelay">;
    }[];
    private constructor();
    getTransferState(): Promise<TransferState>;
    static from<N extends Network>(wh: Wormhole<N>, from: CircleTransferDetails): Promise<CircleTransfer<N>>;
    static from<N extends Network>(wh: Wormhole<N>, from: WormholeMessageId, timeout?: number): Promise<CircleTransfer<N>>;
    static from<N extends Network>(wh: Wormhole<N>, from: CircleMessageId, timeout?: number): Promise<CircleTransfer<N>>;
    static from<N extends Network>(wh: Wormhole<N>, from: TransactionId, timeout?: number): Promise<CircleTransfer<N>>;
    private static fromWormholeMessageId;
    private static fromCircleMessageId;
    private static fromTransaction;
    initiateTransfer(signer: Signer): Promise<TxHash[]>;
    private _fetchWormholeAttestation;
    private _fetchCircleAttestation;
    fetchAttestation(timeout?: number): Promise<AttestationId[]>;
    completeTransfer(signer: Signer): Promise<TxHash[]>;
    static getTransferVaa<N extends Network>(wh: Wormhole<N>, wormholeMessageId: WormholeMessageId, timeout?: number): Promise<AutomaticCircleBridgeVAA<"TransferRelay">>;
}
//# sourceMappingURL=cctpTransfer.d.ts.map