import { Network } from "@wormhole-foundation/sdk-base";
import { GatewayTransferDetails, IbcTransferInfo, Signer, TokenBridge, TransactionId, TxHash, WormholeMessageId } from "@wormhole-foundation/sdk-definitions";
import { Wormhole } from "../wormhole";
import { AttestationId, TransferState, WormholeTransfer } from "../wormholeTransfer";
export declare class GatewayTransfer<N extends Network> implements WormholeTransfer {
    static chain: "Wormchain";
    private readonly wh;
    private readonly gateway;
    private readonly gatewayIbcBridge;
    private readonly gatewayAddress;
    private state;
    private msg;
    transfer: GatewayTransferDetails;
    transactions: TransactionId[];
    vaas?: {
        id: WormholeMessageId;
        vaa?: TokenBridge.VAA<"Transfer" | "TransferWithPayload">;
    }[];
    ibcTransfers: IbcTransferInfo[];
    private constructor();
    getTransferState(): Promise<TransferState>;
    static from<N extends Network>(wh: Wormhole<N>, from: GatewayTransferDetails): Promise<GatewayTransfer<N>>;
    static from<N extends Network>(wh: Wormhole<N>, from: WormholeMessageId, timeout?: number): Promise<GatewayTransfer<N>>;
    static from<N extends Network>(wh: Wormhole<N>, from: TransactionId, timeout?: number): Promise<GatewayTransfer<N>>;
    private static _fromMsgId;
    private static _fromTransaction;
    private static ibcTransfertoGatewayTransfer;
    initiateTransfer(signer: Signer): Promise<TxHash[]>;
    private _transfer;
    private _transferIbc;
    fetchAttestation(timeout?: number): Promise<AttestationId[]>;
    completeTransfer(signer: Signer): Promise<TxHash[]>;
    static getTransferVaa<N extends Network>(wh: Wormhole<N>, whm: WormholeMessageId, timeout?: number): Promise<TokenBridge.VAA<"Transfer" | "TransferWithPayload">>;
    private fromGateway;
    private toGateway;
}
//# sourceMappingURL=gatewayTransfer.d.ts.map